local SUI_A_Time = 0
local elapsed = 0
local SUI_A_Health = "interface\\addons\\SpartanUI_Animation\\Animations\\Health\\HealthBar"
local SUI_A_Cast = "interface\\addons\\SpartanUI_Animation\\Animations\\Cast\\CastBar"
local t_power = { };
local t_powercolor = {};
do
	t_power[0] = "interface\\addons\\SpartanUI_Animation\\Animations\\Mana\\Manabar" --"mana",
	t_power[1] = "interface\\addons\\SpartanUI_Animation\\Animations\\Rage\\RageBar" --"rage",
	t_power[2] = "interface\\addons\\SpartanUI_Animation\\Animations\\Focus\\FocusBar" --"focus", 
	t_power[3] = "interface\\addons\\SpartanUI_Animation\\Animations\\Energy\\EnergyBar" --"energy", 
	t_power[4] = t_power[2] --"happiness", 
	t_power[5] = t_power[0] --"runes", 
	t_power[6] = t_power[0] --"runic power" 
end
do 
	t_powercolor[0] = { 0.4, 0.4, 1 } --mana
	t_powercolor[1] = oUF.colors.power["RAGE"] --rage
	t_powercolor[2] = oUF.colors.power["FOCUS"] --focus
	t_powercolor[3] = oUF.colors.power["ENERGY"] --energy
	t_powercolor[4] = t_power[2] --happines
	t_powercolor[5] = { 1, 1, 1 } --runes
	t_powercolor[6] = t_powercolor[5] --runic power
end
local Sui_anime = function(self,power,powertype)	
	local frameCount = (self.frameCount or 0) % 40 + 1
	self.frameCount = frameCount
	self:SetStatusBarTexture(power..tostring(frameCount))
	if powertype then
	  self.colorSmooth = false;
	  self.colorPower = false;
	   local r,g,b = t_powercolor[powertype][1],t_powercolor[powertype][2],t_powercolor[powertype][3]
	  self:SetStatusBarColor(r,g,b,1)
	end
	return
end

local s_table = { ["player"] = SUI_PlayerFrame, 
				  ["target"] = SUI_targetFrame,
				  ["pet"]	 = SUI_petFrame,
}
local lUnitExists = UnitExists
local lUnitPowerType = UnitPowerType

local SUI_A_OnUpdate = function(self,elapsed)
	SUI_A_Time = SUI_A_Time + elapsed;	
	if SUI_A_Time > 0.2 then
		for unit,frame in pairs(s_table) do
			if lUnitExists(unit) then
				local power = (lUnitPowerType(unit) or 0) % 7
				Sui_anime(frame.Health, SUI_A_Health);
				Sui_anime(frame.Power,t_power[power],power);
				if frame.Castbar.casting or frame.Castbar.channeling then
					Sui_anime(frame.Castbar, SUI_A_Cast);
				end
			end
		end	
		SUI_A_Time = 0
	end
	return
end

do	
	local f=CreateFrame("Frame",nil,UIParent)
	f:SetFrameStrata("BACKGROUND")
	SUI_PlayerFrame.Castbar:SetStatusBarColor(1,1,1,1);	
	f:HookScript("OnUpdate", SUI_A_OnUpdate);
end